#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "geosim.h"
#include "gspriv.h"
#include "config.h"
#include "ietypes.h"

extern BigString templatename, interfacefile;
extern GraphicsFileType GraphFileFmt; 

extern IEWindow dfltWindow; /* newly created window */
extern IEButton dfltButton; /* newly created button */
extern IEField dfltField;
extern IEDragArea dfltDragArea;
extern IEPopup dfltPopup;
/*char *dfltFGCol, *dfltBGCol, *dfltBdrCol;*/
extern boolean showPropCreate;

boolean config_reader(BigString buffer, ReaderStatusType status, void *n)
{
	BigString temp;
	
	if ((status == READ_INIT) || (status == READ_FINAL))
		return(TRUE);         

	if (strcmp(buffer, "interfacefile=") == 0)	{
		if (!GSrdword(interfacefile, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "templatename=") == 0) {
		if (!GSrdword(templatename, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultwforeground=") == 0) {
		if (!GSrdword(dfltWindow.fgcol, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultwbackground=") == 0) {
		if (!GSrdword(dfltWindow.bgcol, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultwbordercol=") == 0) {
		if (!GSrdword(dfltWindow.bdrcol, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultbefg=") == 0) {
		if (!GSrdword(dfltButton.efgcolorname, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultdefg=") == 0) {
		if (!GSrdword(dfltButton.dfgcolorname, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultbbg=") == 0) {
		if (!GSrdword(dfltButton.bgcolor, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultdragcol=") == 0) {
		if (!GSrdword(dfltDragArea.col, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultfieldcol=") == 0) {
		if (!GSrdword(dfltField.col, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultpopefg=") == 0) {
		if (!GSrdword(dfltPopup.efg, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultpopdfg=") == 0) {
		if (!GSrdword(dfltPopup.dfg, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultpopbg=") == 0) {
		if (!GSrdword(dfltPopup.bg, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "defaultpopbdr=") == 0) {
		if (!GSrdword(dfltPopup.bcolor, BIGSTRINGLEN))
			return(FALSE);
		}
	else if (strcmp(buffer, "showpropaftercreate=") == 0) {
		showPropCreate = GSrdboolean();
		}
	else if (strcmp(buffer, "graphicsfileformat=") == 0) {
		if (!GSrdword(temp, BIGSTRINGLEN))
			return(FALSE);
		if (GSstricmp(temp, "BMP_16") == 0)
			GraphFileFmt = BMP_16;
		else if (GSstricmp(temp, "PS_GRAY") == 0)
			GraphFileFmt = PS_GRAY;
		else if (GSstricmp(temp, "PS_COLOR") == 0)
			GraphFileFmt = PS_COLOR;
		else if (GSstricmp(temp, "GIF_16") == 0)
			GraphFileFmt = GIF_16;
		else
			GraphFileFmt = NO_FILE;
		}
	else 
		return(FALSE);
	
	return TRUE;
}
	
void read_config_file(void)
{
	FILE *fp;
	
	if ((fp = GSopen("gbuilder.gcf", "rb")) == NULL)
		GSelog(-1, "Unable to open config file %s.\n", "gbuilder.gcf");
	if (!GSgenreader(fp, config_reader, "gbuilder_config", NULL))
		GSelog(-1, "Error while reading configuration file.\n");
}